package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.AimPlacePosition;
import com.izouma.awesomeadmin.service.AimPlacePositionService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/aimPlacePosition")
public class AimPlacePositionController {

    @Autowired
    private AimPlacePositionService aimPlacePositionService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(AimPlacePosition record) {
        List<AimPlacePosition> pp = aimPlacePositionService.getAimPlacePositionList(record);
        return new Result(true, pp);
    }

    @RequestMapping(value = "/child", method = RequestMethod.GET)
    @ResponseBody
    public Result child(AimPlacePosition record) {
        List<AimPlacePosition> pp = aimPlacePositionService.getAimPlacePositionChildList(record);
        return new Result(true, pp);
    }


    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getAimPlacePosition", method = RequestMethod.GET)
    @ResponseBody
    public Result getAimPlacePosition(@RequestParam(required = false, value = "id") String id) {
        AimPlacePosition data = aimPlacePositionService.getAimPlacePositionById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(AimPlacePosition record) {
        AimPlacePosition data = aimPlacePositionService.getAimPlacePosition(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, AimPlacePosition record) {
        Map<String, Object> result = new HashMap<>();

        List<AimPlacePosition> pp =aimPlacePositionService.getAimPlacePositionByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(AimPlacePosition record) {
        boolean num = aimPlacePositionService.createAimPlacePosition(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateAimPlacePosition(AimPlacePosition record) {
        boolean num = aimPlacePositionService.updateAimPlacePosition(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteAimPlacePosition(AimPlacePosition record) {

        boolean num = aimPlacePositionService.deleteAimPlacePosition(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, AimPlacePosition record) throws Exception {

    List<AimPlacePosition> aimPlacePositions = aimPlacePositionService.getAimPlacePositionList(record);


        String sheetName = "aim_place_position";
        String titleName = "目标点-位置数据表";
        String fileName = "目标点-位置表";
        int columnNumber = 16;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "ID" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "名称" ,   "类别" ,   "坐标X" ,   "坐标Y" ,   "坐标Z" ,   "备注1" ,   "备注2" ,   "备注3" ,   "上级ID" ,   "所属地标ID"  };
        String[][] dataList = new String[aimPlacePositions.size()][16];

        for (int i = 0; i < aimPlacePositions.size(); i++) {

                        dataList[i][0] = String.valueOf(aimPlacePositions.get(i).getId());
                        dataList[i][1] = String.valueOf(aimPlacePositions.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(aimPlacePositions.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(aimPlacePositions.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(aimPlacePositions.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(aimPlacePositions.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(aimPlacePositions.get(i).getName());
                        dataList[i][7] = String.valueOf(aimPlacePositions.get(i).getType());
                        dataList[i][8] = String.valueOf(aimPlacePositions.get(i).getPosX());
                        dataList[i][9] = String.valueOf(aimPlacePositions.get(i).getPosY());
                        dataList[i][10] = String.valueOf(aimPlacePositions.get(i).getPosZ());
                        dataList[i][11] = String.valueOf(aimPlacePositions.get(i).getRemark1());
                        dataList[i][12] = String.valueOf(aimPlacePositions.get(i).getRemark2());
                        dataList[i][13] = String.valueOf(aimPlacePositions.get(i).getRemark3());
                        dataList[i][14] = String.valueOf(aimPlacePositions.get(i).getFrontLevelId());
                        dataList[i][15] = String.valueOf(aimPlacePositions.get(i).getOwnedLandMarkId());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

